*************************************************************************
* Program 8 ADC.ASM To read an analog voltage from the potentiometer VR1*
* and output the digital value on the LEDs Port C and on PLMB channel   *
* Hardware JP2 IN, JP4 optional JP5 ground,JP6 Vcc, Clockwise for Vmax  *
* R1 (47K) and C1 (0.1 microF) to match input voltage                   *
*************************************************************************
PORTB                   EQU  1          ;Define addresses
PORTD                   EQU  3
DDRB                    EQU  5
PLMB                    EQU  $0B
*
ADDATA          EQU  8
ADSTAT          EQU  9
        ORG $250
                lda #$FF    ;set port B for output
                sta DDRB
START:          lda #$20    ;set ADC for channel 0,
                sta ADSTAT  ;system clock,start
WAIT:   brclr  7,ADSTAT,WAIT    ;wait for completion
                lda ADDATA  ;get output
                sta PLMB    ;analog output
                sta PORTB   ;and LEDs
                bra START   ;repeat
