*************************************************************************
* Program 6 BEEP.ASM to generate 0.2 sec beep controlled by bit 0  of   *
* Port A dip switch                                                     *
* Hardware JP1 PC0, JP5 ground, JP6 Vcc                                 *
*************************************************************************

PORTA   EQU     0                       ;Define addresses
PORTC   EQU     2
DDRA    EQU     4
DDRC    EQU     6
      org $50
HI   rmb  1                             ; used for software
LO   rmb  1                             ; delays

              org $250
        lda     #0              ; Set Port A
        sta     DDRA            ; for input
        lda     #$FF            ; and Port C
        sta     DDRC            ; for o/p
HOLD1:  brclr   0,PORTA,HOLD1   ; Wait until bit 0 is set
        lda     #5              ; setup for outer loop
        sta     HI              ; to give overall duration of 0.2 sec
HILP:   lda     #200T           ; setup for inner loop
        sta     LO
LOLP:   lda     #1              ; 
        sta     PORTC           ; Outputs a 1
        lda     #80T            ; for period of
DEL1:   deca                    ; (6 x 80) + 2 + 2 + 4 cycles
        bne     DEL1
        lda     #0              ; Now a 0 for other half of
        sta     PORTC           ; square wave
        lda     #72T            ; 
DEL2:   deca
        bne     DEL2
        dec     LO
        beq     LOFIN
        bra     LOLP
LOFIN:  dec     HI
        bne     HILP
HOLD2:  brset   0,PORTA,HOLD2   ; waits for switch to be returned
        bra     HOLD1           ; to original position

