*************************************************************************
* Program 2 FLASH.ASM To flash the LEDs at a rate set by switches on    *
* Port A using software delay                                           *
* Hardware JP2 in, JP4 Optional, JP5 ground, JP6 Vcc                    *
*************************************************************************
*Define Port Addresses
PORTA           EQU 0   ;Port A (switches) 
PORTB           EQU 1   ;Port B (LEDs) 
DDRA            EQU 4   ;Data Direction Register for PortA
DDRB            EQU 5   ;Data Direction Register for PortB
                ORG $50 ;RAM area
TICKS RMB 1     ;save one location for duration value
                ORG $250        ;start of program area
START:  lda #0          ;set all bits of port A as input
                sta DDRA        ;by setting DDRA to 0
                lda #$FF        ;Port B set to output
                sta DDRB        ;by setting DDRB to 1
LOOP:           lda #0          ;Load zero to Acc
                sta PORTB       ;and output to lights (on) 
                jsr DELAY       ;goto delay subroutine
                lda #$FF        ;load all ones to Acc
                sta PORTB       ;and output to lights (off) 
                jsr DELAY       ;goto delay subroutine
                bra LOOP        ;branch to label LOOP
DELAY:          lda PORTA       ;read switches - delay time. 
                sta TICKS       ;save in RAM
LOOP1:          lda #20T        ;middle loop counter (suffix T for base ten)
LOOP2:          ldx #166T       ;inner loop counter
LOOP3:          decx            ;decrement inner counter
                bne LOOP3       ;end of inner loop
                deca            ;decrement middle loop counter
                bne LOOP2       ;end of middle loop
                dec TICKS       ;decrement outer loop counter
                bne LOOP1       ;end of outer loop
                rts             ;return from subroutine
                END             ;end prog

