*************************************************************************
* Program PLMBEEP.ASM  To generate 0.2 sec beep with PLM channel 	*
* controlled by bit 0 of Port A dip switch				*
* This is louder than program BEEP 					*
* Hardware JP1 PLMA, JP5 ground, JP6 Vcc 		         	*	
*************************************************************************
.
PORTA   EQU     0				;Define addresses
PORTC   EQU     2
DDRA    EQU     4
DDRC    EQU     6
PLMA    EQU     $A			;Pulse length modulation register
      org $50
HI   rmb  1					;For software 
LO   rmb  1					;delay counters

              org $250
        lda     #0    			;Set Port A to O/P
        sta     DDRA
        lda     #$FF			;and Port C to I/P
        sta     DDRC

HOLD1:  brclr   0,PORTA,HOLD1		;Wait until bit 0 of port A is set
        lda     #50			;Set up
        sta     HI			;software
HILP:   lda     #200T			;delay
        sta     LO
LOLP:   lda     #$80			;50% duty cycle at PLMA
        sta     PLMA			;default PLM mode is fast
        dec     LO
        beq     LOFIN
        bra     LOLP
LOFIN:  dec     HI
        bne     HILP
        lda     #0 			;low output
        sta     PLMA			;at PLMA
HOLD2:  brset   0,PORTA,HOLD2 	;Wait until bit 0 of port A is clear
        bra     HOLD1




