***********************************************************************
* Program 5 SEVENSEG.ASM To read lower nibble switches on PortA and   *
* Display on 7 segment display on PortB 			      *
* Uses indexed addressing mode to access segment codes                *
* Hardware JP2 Optional, JP4 In, JP5 ground, JP6 Vcc 		      *		
***********************************************************************
PORTA   EQU  0		;Define addresses
PORTB   EQU  1
DDRA    EQU  4
DDRB    EQU  5
*
*
           org $250
START:  lda    #$0    ; Set Port A
        sta    DDRA   ; for Input
        lda    #$FF   ; Set Port B
        sta    DDRB   ; for output
LOOP:   lda    PORTA  ; read switches
        and    #$0F   ; and disregard top 4 bits
        tax           ; put bottom 4 bits into X
        lda    LIST,X ; read X'th LCD code from list
        sta    PORTB  ; and output it
        bra    LOOP   ; repeat for ever
*
* Codes for 7 segment display, 0 turns on segment
*
LIST:   fcb   %11000000,%11111001,%10100100,%10110000 ; '0','1','2','3'
        fcb   %10011001,%10010010,%10000010,%11111000 ; '4','5','6','7
        fcb   %10000000,%10010000,%10001000,%10000011 ; '8','9','A','b'
        fcb   %11000110,%10100001,%10000110,%10001110 ; 'C','d','E','F'

